import typing as t

from pydantic import Field

from ...types_ import FormatterStylesType
from .. import not_set


class BaseFormatter(not_set.Formatter):
    NAME: t.ClassVar[str] = 'base'
    format_: t.Optional[str] = Field(
        default='{asctime} {levelname:5} {name} {message}',
        alias='format',
    )
    datefmt: t.Optional[str] = '%m-%d %H:%M:%S'
    style: t.Optional[FormatterStylesType] = '{'
