import logging
import typing as t

from pydantic import Field

from ... import utils
from .. import not_set
from .formatters import BaseFormatter


class BaseHandler(not_set.Handler):
    NAME: t.ClassVar[str] = 'base'
    class_: str = Field(default='logging.StreamHandler', alias='()')
    level: t.Optional[str] = utils.get_level_name(logging.DEBUG)
    formatter: t.Optional[str] = BaseFormatter.NAME
