import typing as t

from pydantic import Field

from .. import not_set
from .formatters import BaseFormatter
from .handlers import BaseHandler
from .loggers import BaseLogger


class BaseLog(not_set.Log):
    formatters: t.Optional[dict[str, not_set.Formatter]] = Field(
        default_factory=BaseFormatter.default
    )
    filters: t.Optional[dict[str, not_set.Filter]] = None
    handlers: t.Optional[dict[str, not_set.Handler]] = Field(
        default_factory=BaseHandler.default
    )
    loggers: t.Optional[dict[str, not_set.Logger]] = None
    root: t.Optional[not_set.Logger] = BaseLogger()
