import typing as t

from pydantic import BaseModel
from pydantic import ConfigDict
from pydantic import Field
from pydantic import field_validator
from pydantic_core.core_schema import FieldValidationInfo

from ... import mixins
from ...types_ import StrList


class Handler(
    mixins.NameMixin,
    BaseModel,
):
    model_config = ConfigDict(
        populate_by_name=True,
        extra='allow',
    )
    class_: str = Field(alias='()')  # ! both class and ()
    level: t.Optional[str] = None
    formatter: t.Optional[str] = None
    filters: t.Optional[StrList] = None

    @field_validator(
        'filters',
        mode='before',
    )
    def _list_validator(  # ? TODO
        cls,  # noqa: N805
        json_dict_str: str,
        info: FieldValidationInfo,
    ):
        return StrList.model_validate_json(json_dict_str)
