import typing as t

from pydantic import BaseModel
from pydantic import field_validator
from pydantic_core.core_schema import FieldValidationInfo

from ...types_ import StrList


class Logger(BaseModel):
    level: t.Optional[str] = None
    propagate: t.Optional[bool] = None
    filters: t.Optional[StrList] = None
    handlers: t.Optional[StrList] = None

    @field_validator(
        'filters',
        'handlers',
        mode='before',
    )
    def _list_validator(  # ? TODO
        cls,  # noqa: N805
        json_dict_str: str,
        info: FieldValidationInfo,
    ):
        return StrList.model_validate_json(json_dict_str)
